// RACE X
//
// Written by Mauricio Teichmann Ritter
//
// Copyright (C) 2002, Brazil. All rights reserved.
// 
//

#include "stdafx.h"
#include "cTextWriter.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

cTextWriter::cTextWriter()
{
}

cTextWriter::~cTextWriter()
{
}

int cTextWriter::WriteText(LPDIRECTDRAWSURFACE7 pSurface, char *lpszText, int iX, int iY, bool bFixed)
{
	// Draw text to the screen

	int		pos;
	int		nextx;
	RECT	rcRect;

	nextx = iX;

	while (*lpszText != '\0')
	{
		if (*lpszText != ' ')
		{
			if (*lpszText >= 48 &&
				*lpszText <= 57)
				pos = (int) *lpszText - 48;
			else
				pos = (int) *lpszText - 55;
			if (*lpszText == '@')
				pos = 36;
			if (*lpszText == '-')
				pos = 37;
			if (*lpszText == ',')
				pos = 38;
			if (*lpszText == '.' || *lpszText == ':')
				pos = 39;

			rcRect.left = AA[pos].start;
			rcRect.right = AA[pos].end;
			rcRect.top = 0;
			rcRect.bottom = 15;

			if(*lpszText == ':')
			{
				m_surfLetters.Draw(pSurface, nextx, iY, AA[pos].start, 0, AA[pos].end-AA[pos].start, m_iAlphabet == 1 ? 15 : m_iAlphabet == 2 ? 22 : 8);
				m_surfLetters.Draw(pSurface, nextx+1, iY, AA[pos].start, 4, AA[pos].end-AA[pos].start, m_iAlphabet == 1 ? 7 : m_iAlphabet == 2 ? 11 : 4);
				if(bFixed)
					nextx-=4;
				else
					nextx++;
			}
			else
			{
				m_surfLetters.Draw(pSurface, nextx, iY, AA[pos].start, 0, AA[pos].end-AA[pos].start, m_iAlphabet == 1 ? 15 : m_iAlphabet == 2 ? 22 : 8);
			}
			
			if(bFixed == true)
				nextx+=8;
			else
				nextx += (AA[pos].end - AA[pos].start) + 1;
		}
		else
		{
			switch(m_iAlphabet)
			{
			case 1:
				nextx += 14;
				break;
			case 2:
				nextx += 10;
				break;
			case 3:
				nextx += 4;
				break;
			}
		}
		lpszText++;
	}

	return nextx;
}

void cTextWriter::Create(int iAlphabet)
{
	m_iAlphabet = iAlphabet;
	switch(iAlphabet)
	{
	case 1:
		m_surfLetters.Create(621, 15);
		m_surfLetters.LoadBitmap(GetMainApp()->m_hInst, IDB_DIGITAL_BIG);
		AA = (struct Alphabet*)  &DA[0];
		break;
	case 3:
		m_surfLetters.Create(311, 8);
		m_surfLetters.LoadBitmap(GetMainApp()->m_hInst, IDB_DIGITAL_SMALL);
		AA = (struct Alphabet*)  &SDA[0];
		break;
	case 2:
		m_surfLetters.Create(500, 22);
		m_surfLetters.LoadBitmap(GetMainApp()->m_hInst, IDB_VERDANA);
		AA = (struct Alphabet*) &VA[0];
		break;	
	}
}

void cTextWriter::Destroy()
{
	m_surfLetters.Destroy();
}
